# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class ConsumerGroup(pulumi.CustomResource):
    eventhub_endpoint_name: pulumi.Output[str]
    """
    The name of the Event Hub-compatible endpoint in the IoT hub. Changing this forces a new resource to be created.
    """
    iothub_name: pulumi.Output[str]
    """
    The name of the IoT Hub. Changing this forces a new resource to be created.
    """
    name: pulumi.Output[str]
    """
    The name of this Consumer Group. Changing this forces a new resource to be created.
    """
    resource_group_name: pulumi.Output[str]
    """
    The name of the resource group that contains the IoT hub. Changing this forces a new resource to be created.
    """
    def __init__(__self__, __name__, __opts__=None, eventhub_endpoint_name=None, iothub_name=None, name=None, resource_group_name=None):
        """
        Manages a Consumer Group within an IotHub
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] eventhub_endpoint_name: The name of the Event Hub-compatible endpoint in the IoT hub. Changing this forces a new resource to be created.
        :param pulumi.Input[str] iothub_name: The name of the IoT Hub. Changing this forces a new resource to be created.
        :param pulumi.Input[str] name: The name of this Consumer Group. Changing this forces a new resource to be created.
        :param pulumi.Input[str] resource_group_name: The name of the resource group that contains the IoT hub. Changing this forces a new resource to be created.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not eventhub_endpoint_name:
            raise TypeError('Missing required property eventhub_endpoint_name')
        __props__['eventhub_endpoint_name'] = eventhub_endpoint_name

        if not iothub_name:
            raise TypeError('Missing required property iothub_name')
        __props__['iothub_name'] = iothub_name

        __props__['name'] = name

        if not resource_group_name:
            raise TypeError('Missing required property resource_group_name')
        __props__['resource_group_name'] = resource_group_name

        super(ConsumerGroup, __self__).__init__(
            'azure:iot/consumerGroup:ConsumerGroup',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

